/* Libraries */

/*JUST TEST PURPOSE*/

var fetch  = require('node-fetch');
var moment = require('moment');

//Hotelpartner
const _HP = require("./classHotels.js");

const keys=[];
const nodes = ["NAME","STARS","ADRESSE"];
var   preventdouble     =[]
var   sameItems         =[]
var   notsameitems      =[]
var   arrayofelements   =[]


function startBooking(array,city) {
    return new Promise(resolve=>{
        let i =0;
        array.forEach(t=>{
            t.source = 'Booking.com'
            t.id = i
            i++;
        })

        arrayofelements =array.slice();

        console.log('Done Booking.com fetching found: ' + arrayofelements.length)
        fetchDBData(city).then((r)=>{
            let obj={
                same:sameItems,
                notsame:notsameitems
            }

            resolve(obj)
        })
    })
}

function init()                   {
return new Promise(resolve=>{

    if(keys.length>0)
    {
        foundIndex=[];
        sameItems = [];

        for(let skip=0;skip<arrayofelements.length;skip++){
            keys.forEach(treeitem=>{

                if(treeitem.index == 0)
                    compareHotel(treeitem,skip,arrayofelements)

            })
        }
    }
    else
    {
        console.error("no Array")
    }

    console.log("");
    console.log("Total same found: " +sameItems.length);
    findNotSameHotels().then(res=>{
        resolve(res)
    });
})
}

function generateTree(obj)        {
    return new Promise(resolve=>{
    let i = 0, key;
    for (key in obj)
    {
        nodes.forEach(matchNode=>{
            if(key.toUpperCase().indexOf(matchNode)>=0){

                firstnode = {
                    index:i,
                    match: `${matchNode}`,
                    "key":key
                }
                keys.push(firstnode)
            }
        })
        i++;
    }
    resolve(keys)
    })

}

function compareHotel(item,skipitem,array) {

    let i = skipitem;                        //prevent compare item it self
    const word = parser(array[i][item.key]); //hotelname

    item.points      = 0;                   //reset
    let currentitem  = 0;                   //starts at 0

    array.forEach(inarray =>{

        //Skip Current item
        if(skipitem==currentitem || inarray.source == arrayofelements[i].source|| inarray.id == arrayofelements[i].id ){
            currentitem++;
            return;
        }

        if(preventdouble.indexOf(`${inarray.source}${inarray.id}${arrayofelements[i].source}${arrayofelements[i].id}`)>=0){
            currentitem++;
            return;
        }


        //Search for same values in db || set to 1 if values are not form db
        const geo    = 1;//compareGeo(inarray,array[i])
        const email  = 1;//compareEmail(inarray,array[i])
        const street = 1;//compareStreet(inarray,array[i])


        //Name 1:1 is equal
        if  ( parser(inarray[item.key]) == word  || word.indexOf(parser(inarray[item.key]).substr(2,inarray[item.key].length-2))>=0){
            /*
                           console.log(" ")
                           console.log("Found by fullname 0")
                           console.log(inarray[item.key] +" || " +word)
                           console.log(`where id =${inarray.id }     or id = ${arrayofelements[i].id}`)
                           console.log(`source   =${inarray.source } or source = ${arrayofelements[i].source}`)
             */

                let equals = {
                    0:inarray,
                    1:arrayofelements[i],
                    id:`${inarray.id};${arrayofelements[i].id}`
                };
                inarray.founddb = true;
                arrayofelements[i].founddb = true

                preventdouble.push(`${arrayofelements[i].source}${arrayofelements[i].id}${inarray.source}${inarray.id}`)
                sameItems.push(equals)

                currentitem++;
                return

        }


        //exclude short names
        if(exclude(inarray[item.key]) == null || exclude(word) == null )
        { currentitem++; return; }

        //split by space
        const compare0 = word.split(" ");
        const compare1 = parser(inarray[item.key]).split(" ");

        //word length must be longer than 3
        try{

            if(compare0[0].length <= 3 || compare0[1].length <=3 || compare1[0].length<=3|| compare1[1].length<=3)
            {
                currentitem++;
                return;
            }
        }
        catch (TypeError)
        {
            currentitem++;
            return;
        }

        /// Check if the shorter name  contains in longer name
        let   machedItems       =0;
        let   passedmachedItems = false;
        const notmacheditems    = {
            "compare0": [],
            "compare1": [],
        }
        compare0.forEach(item0=>{
            compare1.forEach(item1=>{
                if(item0.length >= item1.length)
                {

                    if(item0.indexOf(item1)>=0){
                        machedItems++;
                        return;
                    }
                    else {
                        if(notmacheditems.compare1.indexOf(item1)==-1 && notmacheditems.compare0.indexOf(item0)==-1)
                        {
                            notmacheditems.compare0.push(item0)
                            notmacheditems.compare1.push(item1)
                        }
                    }
                }
                else
                {
                    if(item1.indexOf(item0)>=0 && item1.length>3){
                        machedItems++
                        return;
                    }
                    else
                    {
                        if(notmacheditems.compare1.indexOf(item1)==-1 && notmacheditems.compare0.indexOf(item0)==-1 && item1.length>3 )
                        {
                            notmacheditems.compare0.push(item0)
                            notmacheditems.compare1.push(item1)
                        }
                    }
                }
            })
        })

        /*Check if still needed*/
        if(compare0.length == machedItems )
        {
            passedmachedItems=true;
        }

        //Sort and compare Char
        compare0.sort();
        compare1.sort();
        notmacheditems.compare0.sort();
        notmacheditems.compare1.sort();

        let charpoints    = 0;
        let minpoints     = 0
        notmacheditems.compare0.forEach(item0=>{
            notmacheditems.compare1.forEach(item1=>{


                if(item0.length<=3)return;
                if(item1.length<=3)return;

                if(item0.indexOf('IBIS')>=0 &&item1.indexOf('IBIS')>=0){minpoints=minpoints+2}

                const length = item0.length >= item1.length ?item1.length : item0.length;

                const charby1=[];
                const charby2=[];
                let matched2char =0;
                let matched1char =0;

                //Create Array of Char
                for(let i=0;i<length-1;i++)
                {
                    charby2.push(`${item0.charAt(i)}${item0.charAt(i+1)} `)
                    charby1.push(item0.charAt(i))
                }

                //check if char conatins
                for(let i=0;i<length;i++)
                {
                    if(charby2.indexOf(`${item1.charAt(i)}${item1.charAt(i+1)}`)>=0)
                    {
                        matched2char++;
                    }
                    else
                    {
                        minpoints= minpoints-0.3;
                    }

                    if(charby1.indexOf(item1.charAt(i))>=0)
                    {
                        matched1char++;
                    }
                    else
                    {
                        minpoints= minpoints -1.2;
                    }
                }

                //Add points
                if( matched1char <= length+1 &&matched1char >= length-1 )
                {
                    charpoints++
                }
            })
        })


        //Result of CharPoints
        let length1 = inarray[item.key].length;
        let length2 = array[i].length;
            lengthsub = length1>=length2 ?length1- length2: length2-length1; // Longer word - shorter word
        if(passedmachedItems &&   minpoints>=-18 && charpoints>=2 && lengthsub<10){


            if(email==1 || street == 1)
            {

                console.log(" ")
                console.log("Found by points 0 ");
                let equals = {
                    0:inarray,
                    1:arrayofelements[i],
                    id:`${inarray.id};${arrayofelements[i].id}`
                };
                inarray.founddb = true;
                arrayofelements[i].founddb = true

                preventdouble.push(`${arrayofelements[i].source}${arrayofelements[i].id}${inarray.source}${inarray.id}`)
                sameItems.push(equals)

                currentitem++;
                return

             }

        }


        //3 first char is same
        let firstword =false;
        let secondword =false;
        try{

            firstword =  compare1[1].substr(0,3) == compare0[1].substr(0,3);
            secondword = compare1[0].substr(0,3) == compare0[0].substr(0,3);
        }
        catch (TypeError) {
            firstword =  false
            secondword =  false
        }


        //Result
        if(charpoints == compare0.length && compare0.length>1&&minpoints / compare0.length>=-5)  {

            if(inarray.stars == arrayofelements[i].stars){
                let equals = {
                    0:inarray,
                    1:arrayofelements[i],
                    id:`${inarray.id};${arrayofelements[i].id}`
                };
                inarray.founddb = true;
                arrayofelements[i].founddb = true

                preventdouble.push(`${arrayofelements[i].source}${arrayofelements[i].id}${inarray.source}${inarray.id}`)
                sameItems.push(equals)

                currentitem++;
                return
            }
        }

        else if(charpoints == compare0.length && minpoints / compare0.length>=-8.5 && firstword && compare1.length>1||
                charpoints == compare0.length && minpoints / compare0.length>=-8.5 && secondword && compare1.length>1) {
            inarray.points = 80;
            if(inarray.stars && arrayofelements[i].stars){
                inarray.points = inarray.stars == arrayofelements[i].stars ? 95 : 80
            }

            if(inarray.points >80 && (email == 1 || geo == 1))
            {

                let equals = {
                    0:inarray,
                    1:arrayofelements[i],
                    id:`${inarray.id};${arrayofelements[i].id}`
                };
                inarray.founddb = true;
                arrayofelements[i].founddb = true

                preventdouble.push(`${arrayofelements[i].source}${arrayofelements[i].id}${inarray.source}${inarray.id}`)
                sameItems.push(equals)

                currentitem++;
                return
            }


        }

        else if(word.length>15 && inarray[item.key].length>15 && firstword && secondword && minpoints / compare0.length >-11 ) {

            if(inarray.stars && arrayofelements[i].stars ){
                inarray.points = inarray.stars == arrayofelements[i].stars ? 95 : 80;

                if(inarray.points>=95 ){
                    let equals = {
                        0:inarray,
                        1:arrayofelements[i],
                        id:`${inarray.id};${arrayofelements[i].id}`
                    };
                    inarray.founddb = true;
                    arrayofelements[i].founddb = true

                    preventdouble.push(`${arrayofelements[i].source}${arrayofelements[i].id}${inarray.source}${inarray.id}`)
                    sameItems.push(equals)

                    currentitem++;
                    return
                }
            }

        }

    })

}

function compareGeo(value1, value2)        {

    if(value1.geovalue && value2.geovalue){
  let a;

   if(value1.geovalue< value2.geovalue)
     a = value2.geovalue - value1.geovalue
    else
     a = value1.geovalue - value2.geovalue

        if (a.toString().length<5)
        {
            return 1;
        }
    }

    return 0


}

function compareEmail(value1, value2)      {

    if(!value1.manualEmail || !value2.manualEmail)return 0;

    if(value1.manualEmail == 'NN' || value2.manualEmail == 'NN') return 0;

    if(value1.manualEmail && value2.manualEmail){

        // go for Domain
        //    let d1 = value1.manualEmail.indexOf('@');
        //    let d2 = value2.manualEmail.indexOf('@');

        let email1 =  value1.manualEmail.replace(" ","").substr(1,value1.manualEmail.length-2).replace('.','').replace('.','')
        let email2 =  value2.manualEmail.replace(" ","").substr(1,value2.manualEmail.length).replace('.','').replace('.','')


        if(email2.indexOf(email1)>=0)
            return 1

    }
    return 0;
}

function compareStreet(value1,value2)      {

    if(value1.adressStreet) {
        if (value1.adressStreet == value2.adressStreet) {
            return 1;
        }
    }
return 0
}

function parser(w)           {
    let word = w.toUpperCase().replace('APARTHOTEL ','').replace('HOTEL','').replace('-STERNE').replace(/[^\w\s]/gi, '')

    //Remove First Spaces
    if(word.indexOf(" ")== 0)
    while(word.indexOf(" ")== 0){
        word = word.substring(1,word.length)
    }

    if(/\s+$/.test(word))
    while(/\s+$/.test(word)){
            word = word.substring(0,word.length-1)
        }


    return word;
}

function exclude(name)       {


  /*  if(name.toUpperCase().indexOf("ST ")!=-1 ||
        name.toUpperCase().indexOf("ST.")!=-1 ||
        name.toUpperCase().indexOf("KREUZ B")!=-1 |)
        return null;
    else
    */
        return name;
}

function findNotSameHotels() {

    return new Promise(resolve=>{
    let i=0;
    notsameitems = [];
    console.log("===================================")
    console.log('findNotSameHotels:')
    arrayofelements.forEach(h=>{

        if(h.founddb == false && h.source != 'db'){
            console.log(h.name)
            notsameitems.push(h)
            i++;
        }
    });

    if(i==0)console.log("--none--")
     resolve(true);
})

}

function fetchDBData(city)   {
    return new Promise(resolve=>{
    _HP.db.execute(
        `  SELECT H.name , H.id, H.adressRaw, H.geodata, H.stars, H.manualEmail 
        FROM CO2Hotels as H 
        LEFT JOIN CO2CityConfig as C 
        ON H.linkCity = C.linkCity
            WHERE C.name = ? and H.isDead = 0; `,[city],
        function(err, rows, fields)
        {
            if(rows){
                rows.forEach(item=>{
                    let geo =null;
                    if(item.geodata)
                    {
                        geo = item.geodata.split(',');
                        geo =parseInt(geo[0].replace('.',''))+parseInt(geo[1].replace('.',''))
                    }

                    const hotel={
                        id:          item.id,
                        name:        item.name.replace('&amp;','&').replace('&#39;',"\'"),
                        adressRaw:   item.adressRaw,
                        geodata:     item.geodata,
                        geovalue:    geo,

                        stars:       item.stars,
                        manualEmail: item.manualEmail,
                        adressStreet:item.adressStreet,
                        founddb:     'db',
                        source:      "db",
                        points:0,
                    }
                    arrayofelements.push(hotel)
                })
                generateTree(arrayofelements[0]).then(keys=> {

                    /*TEST*/
                    console.log(" ")
                    console.log("Looking for equal Hotels. Place "+city)
                    console.log("........................................")
                    console.log(" ")
                    init().then(res=>{
                        resolve(res)
                    })
                });
            }else {
                console.log(err)
            }
        }
    );
    })
}


//###Export
module.exports ={
    "methods":{
        startBookingCompare:startBooking
    },

}

